package com.configuracion.conexion;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

/**
 * @author carlosf
 */
public class BaseDatos {

    private Statement query;
    private Connection conexion;
    private String url="";

    public BaseDatos() throws ClassNotFoundException, SQLException, InstantiationException, IllegalAccessException {
        String controlador = "org.postgresql.Driver";
        Class.forName(controlador).newInstance();
    }

    public void conectar(String usr, String pwd, String paramUrl) throws SQLException {
    	url = paramUrl;
        conexion = java.sql.DriverManager.getConnection(url, usr, pwd);
        query = conexion.createStatement();
    }

    public void desconectar() {
        if (query != null) {
            try {
                query.close();
            } catch (SQLException e) {
            }
            query = null;
        }
        if (conexion != null) {
            try {
                conexion.close();
            } catch (SQLException e) {
            }
            conexion = null;
        }
    }

    public ResultSet ejecutar(String sql) throws SQLException {
        return query.executeQuery(sql);
    }

    public int actualizar(String sql) throws SQLException {
        int totalRegistros = 0;
        totalRegistros = query.executeUpdate(sql);
        return totalRegistros;
    }

}