package com.configuracion.dao;

import java.sql.SQLException;
import org.jbpm.api.ExecutionService;
import org.jbpm.api.ProcessEngine;
import com.configuracion.conexion.Constantes;
import com.configuracion.conexion.GestorBD;
import com.configuracion.interfaces.IPendientesDao;

public class PendientesDao extends GestorBD implements IPendientesDao {

	private static final long serialVersionUID = 1L;
	protected static ProcessEngine processEngine = null;
	protected static ExecutionService executionService;
	
	public int consultarRegistroPendiente() throws SQLException {
		int cantidadRegistro = 0;
		try {
            bd.conectar(Constantes.usuarioAuditor, Constantes.passwordAuditor, Constantes.bdAuditor);
            sql = "SELECT COUNT(*) FROM detalle_pendiente " +
            	  "WHERE tipo='PG' AND seguimiento='N' ";
            resultSet = bd.ejecutar(sql);
            resultSet.next();
            cantidadRegistro = resultSet.getInt(1);
		} catch (Exception e) {
            e.printStackTrace();
        } finally {
            bd.desconectar();
        }
        return cantidadRegistro;
	}
	
	public void actualizarEstadoSeguimientoPendiente(String estado, String codPendiente, String caf, String numeroFormula, String codComercial, String codPrefijo, String lote) throws SQLException {
		try {
            bd.conectar(Constantes.usuarioAuditor, Constantes.passwordAuditor, Constantes.bdAuditor);
            sql = "UPDATE detalle_pendiente SET seguimiento='"+estado+"' " +
				  "WHERE cod_pendiente='"+codPendiente+"' AND cod_caf='"+caf+"' AND " +
				  "numero_formula='"+numeroFormula+"' AND cod_comercial='"+codComercial+"' AND " +
				  "cod_prefijo='"+codPrefijo+"' AND lote='"+lote+"' ";
            bd.actualizar(sql);
		} catch (Exception e) {
            e.printStackTrace();
        } finally {
            bd.desconectar();
        }
	}
	
}