package com.configuracion.dao;

import java.sql.SQLException;
import com.configuracion.conexion.Constantes;
import com.configuracion.conexion.GestorBD;
import com.configuracion.interfaces.IReposicionDao;
import com.configuracion.modelo.Reposicion;

public class ReposicionDao extends GestorBD implements IReposicionDao {
	
	public int verificarEnvioReposicion(String caf, String comercial) throws SQLException {
		int respuesta = 0;
		try {
            bd.conectar(Constantes.usuarioAmbulatoria, Constantes.passwordAmbulatoria, Constantes.bdAmbulatoria);
            sql = "SELECT COUNT(*) " + 
		      	  "FROM tbl_mv_general_c MG " + 
		      	  "INNER JOIN tbl_mv_documentos_c MD ON (MG.nro_documento = MD.fk_nro_documento) " +
		      	  "WHERE MG.fecha_documento BETWEEN (CURRENT_DATE-2) AND CURRENT_DATE " + 
		      	  "AND MG.fk_tipo_documento = 'ST' " + 
		      	  "AND MG.cod_destino = '"+caf+"' " +
		      	  "AND MD.fk_cod_med_comercial = '"+comercial+"' ";
            resultSet = bd.ejecutar(sql);
            if (resultSet.next())
            	respuesta = resultSet.getInt(1);
		} catch (Exception e) {
            e.printStackTrace();
        } finally {
            bd.desconectar();
        }
        System.out.println("===>Verificar Reposicion: "+respuesta);
        return respuesta;
	}
	
	public String informacionReposicion(String caf, String comercial) throws SQLException {
		Reposicion reposicion = new Reposicion();
        try {
            bd.conectar(Constantes.usuarioAmbulatoria, Constantes.passwordAmbulatoria, Constantes.bdAmbulatoria);
            sql = "SELECT MG.nro_documento, MG.fk_tipo_documento, MG.fecha_documento, MG.cod_origen, MG.cod_destino, MD.fk_cod_med_comercial, MD.cant_unidad " + 
            	  "FROM tbl_mv_general_c MG " + 
            	  "INNER JOIN tbl_mv_documentos_c MD ON (MG.nro_documento = MD.fk_nro_documento) " +
            	  "WHERE MG.fecha_documento BETWEEN (CURRENT_DATE-2) AND CURRENT_DATE " + 
            	  "AND MG.fk_tipo_documento = 'ST' " + 
            	  "AND MG.cod_destino = '"+caf+"' " +
            	  "AND MD.fk_cod_med_comercial = '"+comercial+"' " +
            	  "ORDER BY MG.fecha_documento DESC, MD.cant_unidad DESC " +
        	  	  "LIMIT 1";
            resultSet = bd.ejecutar(sql);
            if (resultSet.next()) {
            	reposicion.setNumeroDocumento(resultSet.getString(1));
            	reposicion.setTipoDocumento(resultSet.getString(2));
            	reposicion.setFechaDocumento(resultSet.getString(3));
            	reposicion.setCafOrigen(resultSet.getString(4));
            	reposicion.setCafDestino(resultSet.getString(5));
            	reposicion.setCodComercial(resultSet.getString(6));
            	reposicion.setCantidad(resultSet.getInt(7));
            }
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            bd.desconectar();
        }
        System.out.println("===>Numero Reposicion: "+reposicion.getNumeroDocumento());
        return reposicion.getNumeroDocumento();
	}
	
	public String verificarCarguePorReposicion(String numeroDocumento, String caf) throws SQLException {
		String respuesta = "N";
		try {
            bd.conectar(Constantes.usuarioAuditor, Constantes.passwordAuditor, Constantes.bdAuditor);
            sql = "SELECT previo AS previo " +
            	  "FROM documentos " +
            	  "WHERE cod_caf = '"+caf+"' AND cod_documento = '"+numeroDocumento+"' ";
            resultSet = bd.ejecutar(sql);
            if (resultSet.next())
            	respuesta = resultSet.getString("previo");
		} catch (Exception e) {
            e.printStackTrace();
        } finally {
            bd.desconectar();
        }
        System.out.println("===>Verificando Cargue: "+respuesta);
        return respuesta;
	}
	
}