package com.configuracion.eventos;

import java.util.HashMap;
import java.util.Map;
import org.jbpm.api.Configuration;
import org.jbpm.api.ExecutionService;
import org.jbpm.api.HistoryService;
import org.jbpm.api.IdentityService;
import org.jbpm.api.ManagementService;
import org.jbpm.api.ProcessEngine;
import org.jbpm.api.ProcessInstance;
import org.jbpm.api.RepositoryService;
import org.jbpm.api.TaskService;

public class CrearInstancias {
  
	protected static ProcessEngine processEngine = null;
	protected static RepositoryService repositoryService;
	protected static ExecutionService executionService;
	protected static ManagementService managementService;
	protected static TaskService taskService;
	protected static HistoryService historyService;
	protected static IdentityService identityService;
	
	public CrearInstancias() throws Exception {
		super();
		inicializar();
	}
	
	protected synchronized void inicializar() {
		if (processEngine==null) {
			processEngine = Configuration.getProcessEngine();
			repositoryService = processEngine.get(RepositoryService.class);
			executionService = processEngine.getExecutionService();
			historyService = processEngine.getHistoryService();
			managementService = processEngine.getManagementService();
			taskService = processEngine.getTaskService();
			identityService = processEngine.getIdentityService();
		}
	}

    public void crearInstancia(Map<String, Object> parametros) {
    	ProcessInstance processInstance;
    	Map<String, Object> parametrosInstancia = new HashMap<String, Object>(); 
    	//identityService.createUser("carlosj", "Carlos Mauricio", "Jaramillo Henao", "carlosj@audifarma.com.co");
    	//identityService.createMembership("carlosj", "manager");
    	/*Se recorre el mapa parametros y se crea una instancia 
    	de ProcesoPendiente diferente para cada pendiente*/
    	for(int i=0; i<Integer.parseInt(parametros.get("cantidadRegistros")+""); i++){
    		parametrosInstancia.put("codPendiente", parametros.get("codPendiente_"+i)); //Codigo Pendiente
    		parametrosInstancia.put("caf", parametros.get("caf_"+i)); //Codigo CAF
    		parametrosInstancia.put("codMunicipio", parametros.get("codMunicipio_"+i)); //Codigo Municipio
    		parametrosInstancia.put("tipoDispensacion", parametros.get("tipoDispensacion_"+i)); //Tipo Dispensacion
    		parametrosInstancia.put("numeroFormula", parametros.get("numeroFormula_"+i)); //Numero Formula
    		parametrosInstancia.put("comercial", parametros.get("comercial_"+i)); //Codigo Comercial
    		parametrosInstancia.put("cantidad", parametros.get("cantidad_"+i)); //Cantidad Pendiente
    		parametrosInstancia.put("tipo", parametros.get("tipo_"+i)); //Tipo
    		parametrosInstancia.put("codPrefijo", parametros.get("codPrefijo_"+i)); //Codigo Prefijo
    		parametrosInstancia.put("lote", parametros.get("lote_"+i)); //Codigo Prefijo
    		System.out.println("===>Crear Instancia "+i+" con Parametros: "+parametrosInstancia);
    		processInstance = executionService.startProcessInstanceByKey("ProcesoPendiente", parametrosInstancia);
        	parametrosInstancia.clear(); //Limpiamos el mapa
    	}
    }
    
}