package com.configuracion.eventos;

import java.sql.SQLException;
import java.util.HashMap;
import java.util.Map;
import org.jbpm.api.activity.ActivityExecution;
import org.jbpm.api.activity.ExternalActivityBehaviour;
import com.configuracion.conexion.Constantes;
import com.configuracion.conexion.GestorBD;
import com.configuracion.dao.PendientesDao;

public class DetallePendiente extends GestorBD implements ExternalActivityBehaviour {

	private static final long serialVersionUID = 1L;
	
	public void execute(ActivityExecution execution) throws SQLException {
		Map<String, Object> parametros = new HashMap<String, Object>();
		PendientesDao pendientes = new PendientesDao();
		int i = 0;
		/*Consultamos la informacion del pendiente (caf, comercial, cantidad) 
		de los registros a los cuales no se les ha hecho seguimiento*/
		try {
            bd.conectar(Constantes.usuarioAuditor, Constantes.passwordAuditor, Constantes.bdAuditor);
            sql = "SELECT DP.cod_pendiente AS codPendiente, C.cod_caf AS codCaf, C.cod_municipio AS codMunicipio, C.tipo_dispensacion AS tipoDispensacion, " +
            	  "DP.numero_formula AS numeroFormula, DP.cod_comercial AS codComercial, DP.valor_novedad AS cantidad, DP.tipo AS tipo, " +
            	  "DP.cod_prefijo AS codPrefijo, DP.lote AS lote " + 
            	  "FROM detalle_pendiente DP " +
            	  "INNER JOIN caf C ON (DP.cod_caf=C.cod_caf) " +
            	  "WHERE tipo='PG' AND seguimiento='N' " +
            	  "ORDER BY DP.fecha, DP.hora";
            resultSet = bd.ejecutar(sql);
            //Armamos el mapa con la cantidad de registros de diferencia
            while(resultSet.next()){
            	parametros.put("codPendiente_"+i, resultSet.getString("codPendiente"));
            	parametros.put("caf_"+i, resultSet.getString("codCaf"));
            	parametros.put("codMunicipio_"+i, resultSet.getString("codMunicipio"));
            	parametros.put("tipoDispensacion_"+i, resultSet.getString("tipoDispensacion"));
            	parametros.put("numeroFormula_"+i, resultSet.getString("numeroFormula"));
            	parametros.put("comercial_"+i, resultSet.getString("codComercial"));
            	parametros.put("cantidad_"+i, resultSet.getString("cantidad"));
            	parametros.put("tipo_"+i, resultSet.getString("tipo"));
            	parametros.put("codPrefijo_"+i, resultSet.getString("codPrefijo"));
            	parametros.put("lote_"+i, resultSet.getString("lote"));
            	i++;
            }
            parametros.put("cantidadRegistros", i);
            //Cambiamos el estado de seguimiento a P (Procesado), para cada instancia del proceso
			for(i=0; i<Integer.parseInt(parametros.get("cantidadRegistros")+""); i++){
				pendientes.actualizarEstadoSeguimientoPendiente("P", //Estado
																parametros.get("codPendiente_"+i)+"", //Codigo Pendiente 
																parametros.get("caf_"+i)+"", //Codigo del CAF
																parametros.get("numeroFormula_"+i)+"", //Numero de la Formula
																parametros.get("comercial_"+i)+"", //Codigo Comercial
																parametros.get("codPrefijo_"+i)+"", //Codigo Prefijo
																parametros.get("lote_"+i)+""); //Lote
			}
            //Creamos las N instancias de ProcesoPendiente
			try {
				CrearInstancias temporal = new CrearInstancias();
				temporal.crearInstancia(parametros);
			} catch (Exception e) {
				e.printStackTrace();
			}
			parametros.clear(); //Limpiar el mapa
		} catch (Exception e) {
            e.printStackTrace();
        } finally {
            bd.desconectar();
        }        
  	}

  	public void signal(ActivityExecution execution, String signalName, Map<String, ?> parameters) {
  		execution.take(signalName);
  	}
  	
}