package com.configuracion.eventos;

import org.jbpm.api.Configuration;
import org.jbpm.api.ExecutionService;
import org.jbpm.api.ProcessEngine;
import org.jbpm.api.ProcessInstance;
import org.jbpm.api.listener.EventListener;
import org.jbpm.api.listener.EventListenerExecution;
import com.configuracion.conexion.GestorBD;
import com.configuracion.dao.PendientesDao;

public class VerificarPendiente extends GestorBD implements EventListener {

	private static final long serialVersionUID = 1L;
	protected static ProcessEngine processEngine = null;
	protected static ExecutionService executionService;
	
	public void notify(EventListenerExecution executionListener) throws Exception {
		if (processEngine == null) {
			processEngine = Configuration.getProcessEngine();
			executionService = processEngine.getExecutionService();
		}
		String cantRegistro = executionListener.getVariable("cantRegistro")+"";
		if (cantRegistro.equals(null)) {
			cantRegistro = new String();
			executionListener.setVariable("cantRegistro", cantRegistro);
		}
		PendientesDao pendientes = new PendientesDao();
		cantRegistro = pendientes.consultarRegistroPendiente()+"";
		executionListener.setVariable("cantRegistro", cantRegistro);
		System.out.println("===>Verificando...");
		if(Integer.parseInt(executionListener.getVariable("cantRegistro").toString())>0){
			ProcessInstance processInstance = executionService.findProcessInstanceById(executionListener.getId());
			processInstance = executionService.signalExecutionById(executionListener.getId(), "evaluar");
		}
	}
	
}